  /************************************************************
  *     # 4-3-1    5 x 5   C-type   magic  squares            *
  *                                                           *
  *        m[1][1]  m[1][2]  m[1][3]  m[1][4]  m[1][5]        *
  *        m[2][1]  m[2][2]  m[2][3]  m[2][4]  m[2][5]        *
  *            1    m[3][2]  m[3][3]  m[3][4]  m[3][5]        *
  *        m[4][1]     g1       g6       r       g5           *
  *        m[5][1]     g2       g7      g4       g3           *
  *                                                           *
  ************************************************************/
     
           #include  <iostream>
           #include  <cstdio>
           #include  <time.h>
           using namespace std;
           #define  swap(x,y)     { (d)=(x);(x)=(y);(y)=(d); }
           #define  move(x,y,z)   { (d)=(x);(x)=(y);(y)=(z);(z)=(d); }
           #define  mov4(x,y,z,w) { (d)=(x);(x)=(y);(y)=(z);(z)=(w); \
                             (w)=(d); }
  
           int     c,n,h,i,j,k,l, kx,lx,ss,s,N;
           int     ii,i3,i4, jj,j3,j4, kk,k3,k4, ll,l3,l4;
           int     p,pp,q,qq,z,zz,a,b,d,r;
           int     g1,g2,g3,gx3,g4,g5,g6,g7;
           time_t  start, finish, duration ;
           int     m[6][6],v[26];
		   int	   e[1400][6], ex[26][262], t[26];
		   int     element(), el_list();
		   int     search(), sub1(), sub2(), print();


		   int  main()
           { 
                start = time(NULL);
                element(); el_list(); 
                search();
			    finish = time(NULL);
                duration = (finish - start);
                printf("%d seconds \n",duration);
				printf("\n Please  input  any  number  and  push  Enter key  \n");
                scanf("%d",&N);
				return 0;
           }


       int print()
	   {   int  i,j;
          
	       m[4][2]=g1; m[4][3]=g6; m[4][4]=r ; m[4][5]=g5;
           m[5][2]=g2; m[5][3]=g7; m[5][4]=g4; m[5][5]=g3;       

           printf("\n No.  %4d0000 \n\n",ss ); 
           for( i=1; i<=5; i++ ) {
              for( j=1; j<=5; j++ ) {
                 printf( "%4d",m[i][j] );
			  }
              printf( "\n" );
		   }                                                           
           printf("\n");
	       return 0;
	   }                          

		   
		   
     

    int  search()
    { 
       v[m[3][1]=1]=1;                    
       for( i=1; i<=c; i++ ){
          v[m[1][1]=e[i][2]]=1;                 
          v[m[2][1]=e[i][3]]=1;                 
          v[m[4][1]=e[i][4]]=1;                   
          v[m[5][1]=e[i][5]]=1;
          for( j=1; j<=c; j++ ){
             if(v[e[j][2]]||v[e[j][3]]||v[e[j][4]]||v[e[j][5]])
               continue;
             v[m[3][2]=e[j][2]]=1;               
             v[m[3][3]=e[j][3]]=1;                
             v[m[3][4]=e[j][4]]=1;                  
             v[m[3][5]=e[j][5]]=1;
             for( ii=0; ii<=2; ii++ ){
                if( ii ) swap( m[1][1],m[ii<<1][1] ); 
                for( kx=1; kx<=ex[m[1][1]][0]; kx++ ){
                   k=ex[m[1][1]][kx];  p=0; pp=0; zz=2;
                   for( z=1; z<=5; z++ ){
                     if( v[e[k][z]] ){ p++; pp=z;}    
				   }
                   if( p>1 ) continue;
                   for( z=1; z<=5; z++ ){
                      if( z!=pp ){ v[m[1][zz]=e[k][z]]=1; zz++;}
				   }
                   for( i3=0; i3<=2; i3++ ){
					  if( i3 ){ swap( m[2][1],m[i3+3][1] );
                        if( m[1][1]>m[5][1] ) continue;                  
					  }
                   for( lx=1; lx<=ex[m[2][1]][0]; lx++ ){
                      l=ex[m[2][1]][lx]; q=0; qq=0; zz=2;
                      for( z=1; z<=5; z++ ){
                         if( v[e[l][z]] ){ q++; qq=z;}     
					  }
                      if( q>1 ) continue;
                      for( z=1; z<=5; z++ ){
                         if( z!=qq ){ v[m[2][zz]=e[l][z]]=1; zz++;}
					  }
                      sub1();
                      v[m[2][2]]=v[m[2][3]]=v[m[2][4]]=v[m[2][5]]=0;
				   }
				}
                move( m[2][1],m[4][1],m[5][1] );
                v[m[1][2]]=v[m[1][3]]=v[m[1][4]]=v[m[1][5]]=0;
			  }
			}
            move( m[1][1],m[2][1],m[4][1] );               
            v[m[3][2]]=v[m[3][3]]=v[m[3][4]]=v[m[3][5]]=0;
		  }
          v[m[1][1]]=v[m[2][1]]=v[m[4][1]]=v[m[5][1]]=0;
	   }
       printf("*********  5 x 5  C-type  ***  end  **********\n\n");
       printf(" found  ss = %d   s = %d  magic  squares \n\n",ss,s);
	   return 0;
    }



    int  sub1()
    {
       int  b,kk,k3,jj,j3,j4;
 
       for( i4=0; i4<=1; i4++){
          if(i4){
            swap( m[5][1],m[4][1] );
            if( m[1][1]>m[5][1] ) continue;
		  }
          for( jj=0; jj<=3; jj++){
             if(jj) swap( m[1][5],m[1][jj+1] );                    
             for( j3=0; j3<=3; j3++){
                if(j3){ b=(((j3-1)*j3)>>1)+2;
                  swap( m[2][4],m[2][b] );                 
				}
                for( j4=0; j4<=3; j4++){
				   if(j4){ b=(((7-j4)*j4)>>1)-1;
                     swap( m[3][3],m[3][b] );                  
				   }
                   g1=65-m[1][5]-m[2][4]-m[3][3]-m[5][1];
                   if( g1<2||g1>25||v[g1] ) continue;
                   v[g1]=1;
                   for( kk=0; kk<=2; kk++){
					  if(kk){ b=kk+2;
                        swap( m[1][2],m[1][b] );                       
					  }
                      for( k3=0; k3<=2; k3++){
                         if(k3){ b=(k3<<1)+1;
                           swap( m[2][2],m[2][b] );                     
						 }

                         sub2();

					  }
                      move( m[2][2],m[2][3],m[2][5] );
				   }
                   move( m[1][2],m[1][3],m[1][4] );
                   v[g1]=0;
				}
                mov4( m[3][2],m[3][4],m[3][5],m[3][3] );               
			 }
             mov4( m[2][2],m[2][3],m[2][5],m[2][4] );               
		  }
          mov4( m[1][2],m[1][3],m[1][4],m[1][5] );                        
       }
       swap( m[5][1],m[4][1] ); 
	   return 0;
    } 




    int sub2()
    { 
	   int  ll,l3,l4,k4,gx3;

       for( k4=0; k4<=2; k4++){ if(k4) swap( m[3][2],m[3][k4+3] ); 
          g2=65-m[1][2]-m[2][2]-m[3][2]-g1;
          if( g2<2||g2>25||v[g2] ) continue;
          v[g2]=1;
          gx3=65-m[1][1]-m[2][2]-m[3][3];
          for( r=2; r<=25; r++){ if( v[r]) continue;
             v[r]=1; 
             g3=gx3-r;
             if( g3<2||g3>25||v[g3] ){ v[r]=0; continue; }
             v[g3]=1;
             for( ll=0; ll<=1; ll++){
                if(ll) swap( m[1][4],m[1][3] ); 
                for( l3=0; l3<=1; l3++){
                   if(l3) swap( m[3][4],m[3][5] ); 
                   g4=65-m[1][4]-m[2][4]-m[3][4]-r;                    
                   if( g4<2||g4>25||v[g4] ) continue;
                   v[g4]=1;
                   for( l4=0; l4<=1; l4++){
                      if(l4) swap( m[2][5],m[2][3] ); 
                      g5=65-m[1][5]-m[2][5]-m[3][5]-g3;           
                      if( g5<2||g5>25||v[g5] ) continue;
                      v[g5]=1;
                      g6=65-m[4][1]-g1-r-g5;
                      g7=65-m[5][1]-g2-g4-g3;
                      if( g6<2||g6>25||g7<2||g7>25||
						  v[g6]||v[g7]||g6==g7 ){ v[g5]=0; continue;
					  }
               
                      s++;
                      if( s==10000 ){ s=0; ss++;
                        print();                               
			            finish = time(NULL);
                        duration = (finish - start);
                        printf("   %d seconds \n",duration);
					}
                    v[g5]=0;              
				  }
                  swap( m[2][5],m[2][3] );                                   
                  v[g4]=0;
				}
                swap( m[3][4],m[3][5] );               
			 }
             swap( m[1][4],m[1][3] );               
             v[g3]=v[r]=0;
		  }
          v[g2]=0;
       }  
       move( m[3][2],m[3][4],m[3][5] );  
	   return 0;
    }



      int  element()
	  { 
         printf( "*********  elements  **********\n" );	 
         for( i=1; i<=11; i++){
            for( j=i+1; j<=15; j++){
               for( k=j+1; k<=20; k++){
				   for( l=k+1; l<=24; l++){
                     for( h=l+1; h<=25; h++){
                        if( i+j+k+l+h==65 ){
                          n++;
                          e[n][1]=i;
                          e[n][2]=j;
                          e[n][3]=k;
                          e[n][4]=l;
                          e[n][5]=h;
                          break;
						}
					 }
				  }
			   }
			} 
		 }

         for( i=1; i<=n; i++ ){
            if( e[i][1]==1 ) c++;
		 }

         printf( "c=%5d\n",c ); printf( "n=%5d\n",n );

         for( i=1; i<=n; i++ ){
            for( j=1; j<=5; j++ ){
               printf( "%4d",e[i][j] );
			}
            printf("\n");
		 }                             
	     return 0;
	  }


	  int  el_list()
	  {
         for( i=1; i<=25; i++){
            ex[i][0]=t[i]=v[i]=0;
		 }

         for( i=245; i<=n; i++){
            for( j=1; j<=5; j++){
               a=e[i][j]; 
	           ex[a][0]++; t[a]++; ex[a][t[a]]=i;
			}
		 }
		 printf("\n");
	     return 0;
	  }



   
   

   



