  /*************************************************************
  *    # 4-4-1   5 x 5   F-type   magic  squares               *
  *                                                            *
  *        m[1][1]     p     m[1][3]     g1    m[1][5]         *
  *           q     m[2][2]  m[2][3]  m[2][4]    g5            *
  *        m[3][1]  m[3][2]     1     m[3][4]  m[3][5]         *
  *           g2    m[4][2]  m[4][3]  m[4][4]    g6            *
  *        m[5][1]     g3    m[5][3]     g4    m[5][5]         *
  *                                                            *
  *************************************************************/         
 
  #include  <iostream>
  #include  <cstdio>
  #include  <time.h>
  using namespace std;                                          
  #define  swap(x,y)      { (d)=(x);(x)=(y);(y)=(d); }
  #define  move(x,y,z)    { (d)=(x);(x)=(y);(y)=(z);(z)=(d); }
  #define  mov4(x,y,z,w)  { (d)=(x);(x)=(y);(y)=(z);(z)=(w); \
                            (w)=(d); }
          
           time_t  start, finish, duration ;                                                               
         
		   int     n=0,ss=0,s=0,b,d,N;
           int     i,j,k,l,p;
		   int     ii,jj,kk,q;
           int     k1,k2,k3,k4,k5,k6,k7,k8,k9;
		   int     f1,f2,f3,f4,f5,f6;
           int     g1,g2,g3,g4,g5,g6;
          
		   int     m[6][6];
		   int	   v[26],e[245][6];  
		   
		   int     element(), print();
		   int     search(),sub1(),sub2();
     


           int   main()
           { 
               start = time(NULL);
               element();
               search();
			   finish = time(NULL);
               duration = (finish - start);
               printf("%d seconds \n\n",duration);
			   printf("\n Please  input  any  number  and  push  Enter key  \n");
               scanf("%d",&N);
			   return 0;
            }



    




  int search()
  {             
     v[m[3][3]=1]=1;
     for( i=1; i<=n-1; i++ ){
       v[m[3][1]=e[i][2]]=1;                  
       v[m[3][2]=e[i][3]]=1;  
       v[m[3][4]=e[i][4]]=1;             
       v[m[3][5]=e[i][5]]=1;
       for( j=i+1;j<=n;j++ ){
         if(v[e[j][2]]||v[e[j][3]]||v[e[j][4]]||v[e[j][5]])
           continue;
         v[m[1][3]=e[j][2]]=1;
         v[m[2][3]=e[j][3]]=1;
         v[m[4][3]=e[j][4]]=1;
         v[m[5][3]=e[j][5]]=1;
         for( k=1; k<=n; k++ ){ 
           if(v[e[k][2]]||v[e[k][3]]||v[e[k][4]]||v[e[k][5]])   
             continue;
           v[m[1][1]=e[k][2]]=1;              
           v[m[2][2]=e[k][3]]=1;                 
           v[m[4][4]=e[k][4]]=1;                     
           v[m[5][5]=e[k][5]]=1;
           for( l=1; l<=n; l++ ){
             if(v[e[l][2]]||v[e[l][3]]||v[e[l][4]]||v[e[l][5]])
               continue;
             v[m[1][5]=e[l][2]]=1;                 
             v[m[2][4]=e[l][3]]=1;                  
             v[m[4][2]=e[l][4]]=1;  
             v[m[5][1]=e[l][5]]=1;
             for( p=2; p<=25; p++ ){
               if( v[p] ) continue;
               v[p]=1;                 
               for( ii=0 ; ii<=3; ii++ ){
                 if( ii ) { b=(((7-ii)*ii)>>1)-1;
				   swap( m[1][1],m[b][b] );}
                 f1=65-p-m[1][1];

                 sub1();
			  
			   }
               mov4( m[1][1],m[2][2],m[4][4],m[5][5] );
               v[p]=0;
			 }
             v[m[1][5]]=v[m[2][4]]=v[m[4][2]]=v[m[5][1]]=0;
		   }
           v[m[1][1]]=v[m[2][2]]=v[m[4][4]]=v[m[5][5]]=0;
		 }
         v[m[1][3]]=v[m[2][3]]=v[m[4][3]]=v[m[5][3]]=0;
	   }
       v[m[3][1]]=v[m[3][2]]=v[m[3][4]]=v[m[3][5]]=0;
	 }
     printf( "\n*****  5 x 5   F-type  ***  end  ****** \n\n" );         
     printf( "found  ss= %d  s = %d  magic  squares \n\n",ss,s);     
     return 0;
   }




   int sub1()     
   {
      for( jj=0; jj<=2; jj++ ){ 
		if( jj )  swap( m[1][3],m[jj<<1][3] );  
        for( kk=0; kk<=3; kk++){
          if( kk ) {  
			b=(((7-kk)*kk)>>1)-1;
		    swap( m[1][5],m[b][6-b] );}
          g1=f1-m[1][3]-m[1][5];
          if( g1<2||g1>25||v[g1] ) continue; 
          v[g1]=1;                    
          for( q=2;q<=25;q++ ){ 
		    if( v[q] ) continue; 
            v[q]=1;
            f2=65-m[1][1]-q;     
            for( k1=0; k1<=2; k1++ ){
              if( k1 ) swap( m[3][1],m[3][k1<<1] );  
              for( k2=0; k2<=2; k2++ ){
		        if( k2 ) { b=k2<<1;
				  swap( m[5][1],m[6-b][b] );}
                g2=f2-m[3][1]-m[5][1];
                if( g2<2||g2>25||v[g2] ) continue;                      
                v[g2]=1;
                for( k3=0; k3<=2; k3++ ){
                  if( k3 ) { b=k3+3;
                    swap( m[2][2],m[b][b] );}
                  f3=65-p-m[2][2];
                  for( k4=0; k4<=2; k4++ ){
					if( k4 ){ swap(m[3][2],m[3][k4+3]);
					  if( m[3][1]>m[3][5] ) break;}
                   
	                  sub2();

				  }
                  move( m[3][2],m[3][4],m[3][5] );
				}
                move( m[2][2],m[4][4],m[5][5] );
                v[g2]=0;
			  }
              move( m[5][1],m[4][2],m[2][4] );
			}
            move( m[3][1],m[3][2],m[3][4] );                 
            v[q]=0;   
		  }
          v[g1]=0;
        }
        mov4( m[1][5],m[2][4],m[4][2],m[5][1] );
      }
      move( m[1][3],m[2][3],m[4][3] );    
	  return 0;
    }




    int sub2()
    {
       int  k5,k6,k7,k8,k9;

       for( k5=0; k5<=1; k5++ ){ 
		 if( k5 ) swap( m[4][2],m[2][4] );  
         g3=f3-m[3][2]-m[4][2];
         if( g3<2||g3>25||v[g3] ) continue; 
         v[g3]=1;
         f4=65-g1-m[2][4];
         for( k6=0; k6<=1; k6++ ){      
           if( k6 ) { swap( m[3][4],m[3][5] ); 
	         if( m[3][1]>m[3][5] ) break;}
           for( k7=0; k7<=1; k7++ ){ 
			 if( k7 ) swap( m[4][4],m[5][5] );  
             g4=f4-m[3][4]-m[4][4];
             if( g4<2||g4>25||v[g4] ) continue;
             v[g4]=1; 
             f5=65-q-m[2][2]-m[2][4];
             for( k8=0; k8<=2; k8++ ){
	    	   if( k8 ) { swap( m[2][3],m[k8+3][3] ); 
			     if( m[1][3]>m[5][3] ) break;}
               g5=f5-m[2][3];
               if( g5<2||g5>25||v[g5] ) continue;
               v[g5]=1;
               f6=65-g2-m[4][2]-m[4][4];
               for( k9=0; k9<=1; k9++ ){
                 if( k9 ) { swap( m[4][3],m[5][3] ); 
		           if( m[1][3]>m[5][3] ) break;}
                 g6=f6-m[4][3];
                 if( g6<2||g6>25||v[g6] ) continue;

                 s++;                                      
	             if( s==10000 ){ s=0; ss++;
				   print();
		           finish = time(NULL);
                   duration = (double)(finish - start);
                   printf("   %d seconds \n\n",duration);
				 }           
			   } 
               swap( m[4][3],m[5][3] ); v[g5]=0;      
			 }
             move( m[2][3],m[4][3],m[5][3] ); v[g4]=0;
		   } 
           swap( m[4][4],m[5][5] );                
		 }                     
         swap( m[3][4],m[3][5] ); v[g3]=0;        
       } 
       swap( m[4][2],m[2][4] );     
	   return 0;
	 }



       int element()
	   {
          printf( "*********  elements  *********\n" );         
          for( i=2; i<=15; i++ ){
             for( j=i+1; j<=20; j++ ){
                for( k=j+1; k<=24; k++ ){
                   for( l=k+1; l<=25; l++ ){
                      if( i+j+k+l==64 ){
                        n++;
                        e[n][1]=1;
                        e[n][2]=i;
                        e[n][3]=j;
                        e[n][4]=k;
                        e[n][5]=l;
                        break;
					  }
				   }
				}
			 }
		  }

          printf( "\n" );
          for( i=1; i<=n; i++ ) {
             for( j=1; j<=5; j++ ) {
                printf( "%4d", e[i][j] );
			 }
             printf( "\n" );
		  }                                              
     
	      printf( "\n n=%5d \n\n",n );
          for( i=1; i<=25; i++ ) v[i]=0;
	      return 0;
	   }



       int print()
	   {  int i,j;

          m[1][2]=p; m[1][4]=g1;
          m[2][1]=q; m[2][5]=g5;
          m[4][1]=g2;m[4][5]=g6;
          m[5][2]=g3;m[5][4]=g4;

          printf(" No.= %4d0000\n\n",ss );         
     
	      for( i=1; i<=5; i++ ) {
             for( j=1; j<=5; j++ ) {
                printf( "%4d",m[i][j] );
			 }
             printf("\n");
		  }   
          printf("\n");  
	      return 0;
	   }

   
