 /**************************************************************************
 *  # 4-5-2     5 x 5   all  magic  squares                                *
 *                           ( central number is 1 `13 )                  *
 **************************************************************************/
    #include  <iostream>
    #include  <cstdio>
    #include  <stdio.h>
    #include  <time.h>
    using namespace std;
   
    #define   SUM         60
    #define   NUM0        (1UL<<24)
     
    #define   MASK        ((1UL<<25)-1)
    #define   Cx(x)  !(cross(x,C[0]))||!(cross(x,C[1]))||!(cross(x,C[2]))||!(cross(x,C[3]))||!(cross(x,C[4]))
    #define   Lx(x)  !(cross(x,L[0]))||!(cross(x,L[1]))||!(cross(x,L[2]))||!(cross(x,L[3]))||!(cross(x,L[4]))
   
	typedef   unsigned int  BITS; 
    BITS      E[1394],C[5],L[5],LL[5],CC[5],D0,D1,bm,b1=NUM0; 
   
	int       n=0,N,i0,i1,i2,i3,j0,j1,j2,j3;
	int       m04,m13,m22,m31,m40;
	
	int       e[1394][5],m[5][5],dia[5],count[13];
    int       per[12][5] = { {1,2,0,3,4},{1,2,0,4,3},{1,3,0,2,4},
	                         {1,3,0,4,2},{1,4,0,2,3},{1,4,0,3,2},
	                         {2,1,0,3,4},{2,1,0,4,3},{3,1,0,2,4},
	                         {3,1,0,4,2},{4,1,0,2,3},{4,1,0,3,2}, };
	int       element(),diagonal(BITS *C,BITS *L),print();
	int       cross(BITS n1,BITS n2),num1(BITS b),num5(BITS n);
	void      column_row();
    long int  s=0,st=0;  
    time_t    start, finish, duration ;




    int  main()
	{     
		start = time(NULL); 
		element();
    	for(int i=0; i<n; i++ ){
		   printf(" no. %4d     ",i+1); num5(E[i]); 
		}
		printf("\n   element  table size =  %4d   \n\n",n);
        printf("   Waite  for  3  days, please. \n\n");
		column_row();
		printf("\n"); 

		for(i=0;i<=12;i++) {
		   printf(" center number = %2d  is  %9d \n",i+1,count[i]); 
		   st=st+count[i];
		}
	    printf("\n                 Total = %9d \n\n",st+st-count[12]);	
		finish = time(NULL);
        duration = (finish - start);
        printf("%d seconds \n",duration);
		printf("\n Please  input  any  number  and  push  Enter key  \n");
        scanf("%d",&N);
        return 0;
    }


   
    void  column_row()
    {  BITS   C01,C012,C0123, L01,L012,L0123;

	   	for(m22=0; m22<=12; m22++){ s=0;

		   for(i0=0; i0< n; i0++) if(E[i0] & (NUM0>>m22)){ 
		      C[0]=E[i0];
   	       for(i1=0; i1< n; i1++) if(!(E[i1] & C[0])){ 
		      C[1]=E[i1]; 
			  C01 = C[0]|C[1];
	       for(i2=i1+1; i2< n; i2++) if(!(E[i2] & C01)) { 
		      C[2]=E[i2]; C012=C01|C[2];
           for(i3=i2+1; i3< n; i3++) if(!(E[i3] & C012)){ 
		      C[3]=E[i3]; C0123 = C012|C[3];
              C[4] = MASK & ~C0123; if(C[4]>C[3]) continue;
        
           for(j0=i0+1; j0<n; j0++) if(E[j0] & (NUM0>>m22)){ 
		      if(Cx(L[0]= E[j0])) continue;  
		   for(j1=0; j1<n; j1++) if(!(E[j1] & L[0])){ 
		      if(Cx(L[1]= E[j1])) continue; 
		      L01=L[0]|L[1];
		   for(j2=j1+1; j2<n; j2++) if(!(E[j2] & L01)) { 
		      if(Cx(L[2]= E[j2])) continue;
              L012=L01|L[2];
           for(j3=j2+1; j3<n; j3++) if(!(E[j3] & L012)){ 
		      if(Cx(L[3]= E[j3])) continue; 
              L0123 = L012|L[3];
		      L[4] = MASK & ~L0123; 
			  if(L[4]>L[3]||Cx(L[4])) continue;
              diagonal(C,L);  
		   }}}}}}}}
		   count[m22]=s;  
           printf(" center number = %2d  is  %9d \n",m22+1,count[m22]);
		 
		}
	
	 }


	
     int  diagonal(BITS *C,BITS *L)
	 {  
		dia[0] = m22;
	    for(int k=0; k<n; k++) if(E[k] & (NUM0>>m22)){ D0= E[k]; 
		   if(Cx(D0)||Lx(D0)) continue;    
          
		   int  nn=0; 
		   for( int i=1; i<5; nn++) if( nn != m22){ 	  
		        if( D0 & (NUM0>>nn)) { dia[i] = nn ; i++; }
		   }             
	       
          for(int p=0; p<12; p++ ) {
             m[0][0]= dia[per[p][0]]; m[1][1]= dia[per[p][1]];
             m[2][2]= m22;
             m[3][3]= dia[per[p][3]]; m[4][4]= dia[per[p][4]];  
           
		     for(int q=0; q<5; q++ ) {  bm = (NUM0>>m[q][q]);
		        for( i=0; i<5; i++ ) { if( bm & C[i] ) CC[q]= C[i]; }
                for( i=0; i<5; i++ ) { if( bm & L[i] ) LL[q]= L[i]; }
			 }
       
		     D1 = LL[0]&CC[4]|LL[1]&CC[3]|LL[2]&CC[2]|LL[3]&CC[1]|LL[4]&CC[0];
             if(D1>D0) continue;	  
          
		     m04 = num1(LL[0]&CC[4]); m13 = num1(LL[1]&CC[3]);
             m31 = num1(LL[3]&CC[1]); m40 = num1(LL[4]&CC[0]);  
           
		     if( m04+m13+m22+m31+m40 == SUM ){ s++; 
			 if( s % 10000==0 ) printf(" center number = %2d  is  %9d \n",m22+1,s);      
			 
			 }
		  }
		}
		return 0;
	 }
	


     int cross(BITS n1,BITS n2)
     { 
		b1= NUM0;     
	    for(int i=0; i<25;i++ ) { if((n1&n2)==b1) return 1; b1>>=1; }  
	    return 0;
     }   
 


     int num1(BITS b)
     {
        b1= NUM0;
        for( int n=0; n<25; n++){ if( b & b1 ) return n ; b1 >>= 1; } 
	    return 0;
     }


     int num5(BITS n)
	 {
		for(int i=0;i<25;i++) if(n & (NUM0>>i)){ printf("%3d",i); }
        printf("\n");
		return 0;
	 }


     int print()
     { 
        printf(" No.%9d \n\n",s); 
        for(int i=0;i<5;i++){
           for(int j=0;j<5;j++){ m[i][j] = num1(LL[i] & CC[j])+1;   
              printf("%3d",m[i][j]);
		   }
           printf("\n");   
		}      
		finish = time(NULL); duration = (finish - start);
		printf("                        %d seconds \n",duration);
	    return 0;
	 }
  

     int element()
	 {  int  i,j,k,l,h;     

        for( i=0; i<=10; i++ ) {
          for( j=i+1; j<=13; j++ ) {
            for( k=j+1; k<=18; k++ ) {
              for( l=k+1; l<=23; l++ ) {
                for( h=l+1; h<=24; h++ ) {
                  if( i+j+k+l+h == SUM) {
					e[n][0]=i;
					e[n][1]=j;
					e[n][2]=k;
					e[n][3]=l;
					e[n][4]=h;
					n++; break;
				  }
				}
			  } 
			}
		  }
		}
       
 	    for( i=0; i<n; i++ ) {
		   for(j=0; j<5;j++ ) { E[i]|=(NUM0>>e[i][j]); }
        } 
		return 0;
   	}
   


   


